/*
    Copyright (C) 2002, Steve Lhomme <steve.lhomme @ free.fr>
    This file is part of mpa2wav.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/**
    \file
*/

#include "wav.h"

START_M2W_NAMESPACE

void WAV_file::WriteHead(const uint16 extra_format, const uint32 data_size, bool seek_to_start)
{
    RIFF_file::WriteHead(data_size + FormatEx().Size() + 4 + 4 + 4 + 4 + extra_format,seek_to_start);
    // 4 : WAVE fourCC
    // 4 : format fourCC
    // 4 : chunk size

    myChunk.WriteHeader(myFile);
}

uint32 WAV_file::Write(const binary * buffer, const uint32 buffer_size)
{
    return myFile.Write(buffer, buffer_size);
}

void WAV_file::WriteDataStart(const uint32 data_size)
{
    myDataChunk.setSize(data_size);
    myDataChunk.WriteHeader(myFile);
}

void WAV_file::WriteSampleNumber(const uint32 sample_number)
{
    myFactChunk.setSampleNumber(sample_number);
    myFactChunk.Write(myFile);
}

END_M2W_NAMESPACE
